#!/usr/bin/perl
###
###↓設定
#$LEFT=175;
#$TOP=188;
#$LEFT=1432;
#$TOP=189;
#$LEFT=153;
#$TOP=121;
#$LEFT=154;
#$TOP=190;

$CAP='/tmp/capture.tif';

$WAIT_S=1;
$WAIT_L=5;
$WAIT_I=1;
$WAIT_F=2;

$DIFF_ROOM=70;
$DIFF_BAR=200;
$DIFF_ROUTE=23;
$DIFF_RESULT=20;
$DIFF_FACILITY=30;



$MAKE=1;
$MAKE_MIN=60;
#@MAKE_WOOD=('風杖グリダヴォル',0,7,5);
#@MAKE_WOOD=('モウメントアロー',0,2,8);
#@MAKE_WOOD=('カテジナ六世',0,2,10);
#@MAKE_WOOD=('魔槍ゲイボルグ',0,3,5);
#@MAKE_WOOD=('ランブルローズ',0,7,10);
#@MAKE_WOOD=('魔黒弓',0,2,0);
@MAKE_STONE=('モルゲンステルン',0,5,6);
#@MAKE_STONE=('ネクロリダク',0,5,8);
#@MAKE_STONE=('七蝶星',0,5,9);
#@MAKE_STONE=('パニッシュメント',0,6,4);
#@MAKE_STONE=('巨人鎚シャルウル',0,4,5);
#@MAKE_STONE=('国宝ラインハイト',0,5,0);
#@MAKE_IRON=('剛剣ペルグランデ',0,0,8);
#@MAKE_IRON=('八丁念仏',0,1,7);
#@MAKE_IRON=('魂の胸当て',1,2,2);
#@MAKE_IRON=('クリスタルヘルム',1,3,3);
#@MAKE_IRON=('エリクシル',0,0,1);
@MAKE_IRON=('煉獄槍',0,3,0);
@MAKE_TEST=('テスト',0,5,9);

@MAKE_IRON=('煉獄槍',0,0,5);
@MAKE_WOOD=('風杖グリダヴォル',0,0,5);
@MAKE_STONE=('モルゲンステルン',0,6,10);

@QUEST=('C',0,14);
#@QUEST=('M-2-6',3,2);
#@QUEST=('M-7-1',3,7);#ターコイズ
#@QUEST=('M-7-6',3,2);
@QUEST=('M-7-8',3,0);#クリスタル
#@QUEST=('M-8-1',2,7);
#@QUEST=('M-8-6',2,2);
#@QUEST=('M-9-4',1,3);
#@QUEST=('M-9-5',1,2);
#@QUEST=('M-10-4',0,3);
#@QUEST=('M-2-1-2',2,5);
@QUEST=('E',0,0);

$LABY='L-1';
###↑設定
###↓クエスト別選択ルーチン

$SELECT{'M-2-6'}=sub{
	&RouteSelect('船尾側に向かおう！',25);
};
$SELECT{'M-7-1'}=sub{
	&RouteSelect('困った時の左だな！',-25);
};
$SELECT{'M-7-8'}=sub{
	&RouteSelect('そうだな。みんなで部屋を調べよう。',-25);
};
$SELECT{'M-8-1'}=sub{
	&RouteSelect('テオロギア鍾乳洞に向かおう。',25);
};
$SELECT{'M-8-6'}=sub{
	&RouteSelect('東の方から向かおう。',25);
};
$SELECT{'L-1'}=sub{
	&RouteSelect('回廊をまっすぐ進む',-50);
	&RouteSelect('明るい通路を進む',-50);
	&RouteSelect('木の扉がある',-50);
	&RouteSelect('見慣れた回廊を進む',-50);
};
$SELECT{'L-2'}=sub{
	&RouteSelect('回廊をまっすぐ進む',-50);
	&RouteSelect('声の聞こえる通路を進む',50);
	&RouteSelect('透き通った道を進む',25);
	&RouteSelect('静かな道を進む',-25);
};

###↑クエスト別選択ルーチン
###

use X11::GUITest;
use Imager;
$|=1;
$START=time;
$FOOD=40;
foreach(@ARGV){
	$FOOD=12 if($_ eq 'l');
	$FOOD=65 if($_ eq 'h');
	$MAKE=0 if($_ eq 'q');
}

&Positioning;
&DiffWait('社長室.tif',291,305,'社長室',$DIFF_ROOM);
&MakeStart(@MAKE_TEST) if($MAKE==2);
loop:while(1){
	if($MAKE){
		my $wood=&BarCheck('#00B0B2.tif',763,32,75,$DIFF_BAR);
		my $stone=&BarCheck('#00B0B2.tif',763,53,75,$DIFF_BAR);
		my $iron=&BarCheck('#00B0B2.tif',866,53,75,$DIFF_BAR);
		if($wood>=$MAKE_MIN&&$stone>=$MAKE_MIN&&$iron>=$MAKE_MIN){
			$wood=0 if(!@MAKE_WOOD);
			$stone=0 if(!@MAKE_STONE);
			$iron=0 if(!@MAKE_IRON);
			if($wood>$stone&&$wood>$iron){
				&MakeStart(@MAKE_WOOD);
			}elsif($stone>$iron){
				&MakeStart(@MAKE_STONE);
			}elsif($iron){
				&MakeStart(@MAKE_IRON);
			}
		}
	}
	if(&BarCheck('#00B0B2.tif',866,32,75,$DIFF_BAR)<$FOOD){
		$COUNT{'夢幻の迷宮'}++;
		print "夢幻の迷宮 $COUNT{'夢幻の迷宮'}回目\n";
		&QuestStart($LABY);
	}else{
		$COUNT{'クエスト'}++;
		print "クエスト $COUNT{'クエスト'}回目\n";
		&QuestStart(@QUEST);
	}
	print "社長室 @{[int((time-$START)/60)]}分経過\n";
	for(my $i=0;$i<100;$i++){
		if(&DiffCheck('社長室.tif',291,305)<$DIFF_ROOM){
			next(loop);
		}
		&TimerClick(0,748,301);
		sleep($WAIT_I);
	}
	exit;
}
sub Positioning{
	return if($TOP&&$LEFT);
	print "座標確認\n";
	`import -silent -window root $CAP`;
	my $cap=Imager->new(file=>"$CAP");
	my($w,$h,$y);
	$w=$cap->getwidth();
	$h=$cap->getheight();
	$y=589;
	for(my $x=0;$x<$w-950;$x++){
		my $c=$cap->getpixel(x=>$x,y=>$y);
		next if($c->equals(other=>$cap->getpixel(x=>$x+1,y=>$y),ignore_alpha=>1));
		next if($c->equals(other=>$cap->getpixel(x=>$x+950,y=>$y),ignore_alpha=>1));
		next if(!$c->equals(other=>$cap->getpixel(x=>$x+951,y=>$y),ignore_alpha=>1));
		for(my $yy=$y-1;$yy>0;$yy--){
			next if(!$c->equals(other=>$cap->getpixel(x=>$x+1,y=>$yy),ignore_alpha=>1));
			next if(!$c->equals(other=>$cap->getpixel(x=>$x+1,y=>$yy+591),ignore_alpha=>1));
			$TOP=$yy+1;
			$LEFT=$x+1;
			last;
		}
		last;
	}
	if(!$TOP||!$LEFT){
		print "座標確認失敗\n";
		exit;
	}
	print "座標=$LEFT:$TOP\n";
}
sub MakeStart{
	&TimerClick(0,172,187);
#	&ImageClick('施設.tif',209,445,'施設');
	&DiffWait('#BBC726.tif',82,6,'施設',$DIFF_FACILITY);
	&TimerClick(0,209,445);
	&ImageClick('#FFFFFF.tif',165,453,'装備開発');
	print "$_[0]\n";
#	&ImageWait('#00B0B2.tif',467,130);
	&ImageWait('#D0D0D0.tif',605,554);
	&TimerClick(0,592+int($_[1]*133)-133,182);
	&TimerClick(0,86+int($_[2]*36),182);
	for($i=0;$i<int($_[3]/5);$i++){
		&TimerClick(0,128,226);
	}
	&TimerClick(0,188,263+$_[3]%5*49);
	exit if($MAKE==2);
	if(&ImageCheck('#FFFFFF.tif',413,549)){
		&TimerClick(0,413,549);
		&TimerClick(0,413,473);
		&ImageClick('#D0D0D0.tif',525,444);
	}
	&TimerClick(0,40,40);
	&DiffWait('社長室.tif',291,305,'社長室',$DIFF_ROOM);
}
sub QuestStart{
	&TimerClick(0,216,321);
#	&ImageWait('クエスト.tif',106,161,'クエスト');
	&DiffWait('#AB0F43.tif',69,26,'受注',$DIFF_QUEST);
	sleep($WAIT_S);
	if(substr($_[0],0,1) eq 'C'){
		if(!&ImageCheck('#D0D0D0.tif',29,570)){
			&TimerClick(0,900,90);
			&ImageWait('#D0D0D0.tif',29,570);
		}
#		&TimerClick(0,300,180+$_[1]*32);
#		for($i=0;$i<int($_[2]/8);$i++){
#			&TimerClick(0,171,566);
#		}
#		&TimerClick(0,130,185+$_[2]%8*48);
#		&TimerClick(0,500,280);
		&TimerClick(0,814,521);
		&TimerClick($WAIT_S,396,391);
	}elsif(substr($_[0],0,1) eq 'L'){
		if(&ImageCheck('#D0D0D0.tif',29,570)){
			&TimerClick(0,29,570);
			&DiffWait('#AB0F43.tif',69,26,'',$DIFF_QUEST);
		}
		if(&ImageCheck('#FFFFFF.tif',74,125) || &ImageCheck('#FFFFFF.tif',78,127)){
			&TimerClick(0,92,126);
		}
		&TimerClick(0,656,341);
		&TimerClick('#FFFFFF.tif',806,432);
		&ImageClick('#FFFFFF.tif',364,392);
	}else{
		if(!&ImageCheck('#FFFFFF.tif',74,125) && !&ImageCheck('#FFFFFF.tif',78,127)){
			if(substr($_[0],0,1) eq 'E'){
				&TimerClick(0,315,222);
			}
			&TimerClick(0,176,209+$_[1]*74);
		}
		&TimerClick(0,176,197+$_[2]*48);
		&TimerClick('#FFFFFF.tif',806,432);
		&ImageClick('#FFFFFF.tif',364,392);
	}
#	&ImageClick('#D0D0D0.tif',936,445,'早送り',2,2);
#	for(my $i=0;$i<5;$i++){
#		sleep($WAIT_F);
#		last if(&ImageCheck('#D0D0D0.tif',916,444));
#		&TimerClick(0,936+2,445+2) if(&ImageCheck('#D0D0D0.tif',936,444));
#	}
	&{$SELECT{$_[0]}} if($SELECT{$_[0]});
#	&ImageClick('#00B0B2.tif',463,52,'結果待ち');
	&DiffWait('クエスト結果.tif',933,579,'結果待ち',$DIFF_RESULT);
}
sub TimerClick{
	for(my $i=$_[0];$i>0;$i--){
		print "\r$i  ";
		sleep(1);
	}
	print "\r   \r";
	print " $_[3]\n" if($_[3]);
	my @pos=X11::GUITest::GetMousePos;
	X11::GUITest::MoveMouseAbs($LEFT+$_[1],$TOP+$_[2]);
	X11::GUITest::ClickMouseButton(X11::GUITest::M_LEFT);
	sleep($WAIT_S);
	X11::GUITest::MoveMouseAbs($pos[0],$pos[1]);
}
sub ImageClick{
	&ImageWait(@_);
	my @pos=X11::GUITest::GetMousePos;
	X11::GUITest::MoveMouseAbs($LEFT+$_[1]+$_[4],$TOP+$_[2]+$_[5]);
	X11::GUITest::ClickMouseButton(X11::GUITest::M_LEFT);
	sleep($WAIT_S);
	X11::GUITest::MoveMouseAbs($pos[0],$pos[1]);
}
sub ImageWait{
	print "$_[3]\n" if($_[3]);
	sleep($WAIT_S);
	my $c=Imager->new(file=>"image/$_[0]")->getpixel(x=>0,y=>0);
	for(my $i=0;$i<1000;$i++){
		`import -silent -window root -crop 1x1+@{[$LEFT+$_[1]]}+@{[$TOP+$_[2]]} $CAP`;
		my $cap=Imager->new(file=>"$CAP");
#@c1=$c->rgba;
#@c2=$cap->getpixel(x=>0,y=>0)->rgba;
#print "$c1[0],$c1[1],$c1[2]:$c2[0],$c2[1],$c2[2]\n";
		if($c->equals(other=>$cap->getpixel(x=>0,y=>0),ignore_alpha=>1)){
			sleep($WAIT_I);
			`import -silent -window root -crop 1x1+@{[$LEFT+$_[1]]}+@{[$TOP+$_[2]]} $CAP`;
			$cap=Imager->new(file=>"$CAP");
			return if($c->equals(other=>$cap->getpixel(x=>0,y=>0),ignore_alpha=>1));
		}
		sleep($WAIT_I);
	}
	exit;
}
sub ImageCheck{
	my $c=Imager->new(file=>"image/$_[0]")->getpixel(x=>0,y=>0);
	`import -silent -window root -crop 1x1+@{[$LEFT+$_[1]]}+@{[$TOP+$_[2]]} $CAP`;
	my $cap=Imager->new(file=>"$CAP");
	return($c->equals(other=>$cap->getpixel(x=>0,y=>0),ignore_alpha=>1));
}
sub BarCheck{
	my $d=$_[4]||100;
	my $c=Imager->new(file=>"image/$_[0]")->getpixel(x=>0,y=>0);
	`import -silent -window root -crop $_[3]x1+@{[$LEFT+$_[1]]}+@{[$TOP+$_[2]]} $CAP`;
	my $cap=Imager->new(file=>"$CAP");
	for(my $i=0;$i<$_[3];$i++){
		return($i) if(&ColorDiff($c,$cap->getpixel(x=>$i,y=>0))>$d);
	}
	return($_[3]);
}
sub ColorDiff{
	@c1=$_[0]->rgba;
	@c2=$_[1]->rgba;
	my $d+=abs($c1[0]-$c2[0]);
	$d+=abs($c1[1]-$c2[1]);
	$d+=abs($c1[2]-$c2[2]);
#	print "$d:$c1[0]-$c2[0],$c1[1]-$c2[1],$c1[2]-$c2[2]\n";
	return($d);
}
sub DiffWait{
	print "$_[3]\n" if($_[3]);
	my $d=$_[4]||100;
	my $c=Imager->new(file=>"image/$_[0]")->getpixel(x=>0,y=>0);
	for(my $i=0;$i<1000;$i++){
		`import -silent -window root -crop 1x1+@{[$LEFT+$_[1]]}+@{[$TOP+$_[2]]} $CAP`;
		my $cap=Imager->new(file=>"$CAP");
#@c1=$c->rgba;
#@c2=$cap->getpixel(x=>0,y=>0)->rgba;
#print "$c1[0],$c1[1],$c1[2]:$c2[0],$c2[1],$c2[2]\n";
		return if(&ColorDiff($c,$cap->getpixel(x=>0,y=>0))<$d);
		sleep($WAIT_I);
	}
	exit;
}
sub DiffCheck{
	my $c=Imager->new(file=>"image/$_[0]")->getpixel(x=>0,y=>0);
	`import -silent -window root -crop 1x1+@{[$LEFT+$_[1]]}+@{[$TOP+$_[2]]} $CAP`;
	my $cap=Imager->new(file=>"$CAP");
	return(&ColorDiff($c,$cap->getpixel(x=>0,y=>0)));
}
sub RouteSelect{
	print "$_[0]\n";
	for(my $i=0;$i<100;$i++){
		&ImageWait('#E75145.tif',693,531);
		`import -silent -window root -crop 350x2+@{[$LEFT+300]}+@{[$TOP+281]} $CAP`;
		my $cap=Imager->new(file=>"$CAP");
#print &ColorDiff($cap->getpixel(x=>0,y=>0),$cap->getpixel(x=>0,y=>1)).",".&ColorDiff($cap->getpixel(x=>1,y=>0),$cap->getpixel(x=>1,y=>1)).",".&ColorDiff($cap->getpixel(x=>348,y=>0),$cap->getpixel(x=>348,y=>1)).",".&ColorDiff($cap->getpixel(x=>349,y=>0),$cap->getpixel(x=>349,y=>1))."\n";
#print &ColorDiff($cap->getpixel(x=>0,y=>0),$cap->getpixel(x=>1,y=>0)).",".&ColorDiff($cap->getpixel(x=>348,y=>0),$cap->getpixel(x=>349,y=>0))."\n";
#exit;
		if(
			&ColorDiff($cap->getpixel(x=>0,y=>0),$cap->getpixel(x=>0,y=>1))<$DIFF_ROUTE &&
			&ColorDiff($cap->getpixel(x=>1,y=>0),$cap->getpixel(x=>1,y=>1))<$DIFF_ROUTE &&
			&ColorDiff($cap->getpixel(x=>348,y=>0),$cap->getpixel(x=>348,y=>1))<$DIFF_ROUTE &&
			&ColorDiff($cap->getpixel(x=>349,y=>0),$cap->getpixel(x=>349,y=>1))<$DIFF_ROUTE &&
			&ColorDiff($cap->getpixel(x=>0,y=>0),$cap->getpixel(x=>1,y=>0))>$DIFF_ROUTE &&
			&ColorDiff($cap->getpixel(x=>348,y=>0),$cap->getpixel(x=>349,y=>0))>$DIFF_ROUTE
		){
			&TimerClick(0,474,295+$_[1]);
			sleep($WAIT_L);
			return;
		}
	}
}
